title: Getting Started
toc: [Documentation, Getting Started]

# Getting Started with Crossbar.io

If you want to start programming apps using Crossbar.io, the following contains a number of good starting points.

## Quick Start

No time? Try the [Quick Start](Quick Start).

## Start in your Programming Language

Crossbar.io enables polyglot frontends and backends. Since all traffic is handled via WAMP, the implementation language of a component is transparent to all other components.

**You're free to choose one *or more* languages to fit app needs and your preferences:**

* [Getting started with JavaScript in the Browser](Getting started with Browser)
* [Getting started with JavaScript and NodeJS](Getting started with NodeJS)
* [Getting started with Python](Getting started with Python)
* [Getting started with PHP](Getting started with PHP)
* [Getting started with Java](Getting started with Java)
* [Getting started with C#](Getting started with CSharp)
* [Getting started with C++](Getting started with Cplusplus)
* [Getting started with Erlang](Getting started with Erlang)

## Application Templates

Crossbar.io can generate a skeleton application from [Application Templates](Application Templates) for you. This enables you to quickly start a new project from working code.

## IoT Cookbook

The **[IoT Cookbook](http://crossbario.com/iotcookbook)** is your starting point if you want to **integrate devices like the RaspberryPi, Arduino Yun and others with Crossbar.io**.
