title: Installation
toc: [Documentation, Installation]

# Installing Crossbar.io

Below are different ways of installing Crossbar.io. **We recommend our [binary packages](#binary-packages) or [Docker images](#docker-images).**

If you have an installation related question, please also check the [Installation FAQ](Installation FAQ).


## Binary Packages

We provide binary packages that contain completey self-contained and optimized builds of Crossbar.io and all dependencies for the following platforms:

* [Installation on Ubuntu and Debian](Installation on Ubuntu and Debian)
* [Installation on CentOS and RedHat](Installation on CentOS and RedHat)
* [Installation on FreeBSD](Installation on FreeBSD)

Using the binary packages above, whether on bare metal, on virtual machines or within OS containers (Docker et al), is the recommended way to deploy Crossbar.io in production.


## Docker Images

We provide official Docker images for Crossbar.io in different flavors. This is both a quick way getting started with Crossbar.io and a good approach going to production:

* [Using Docker](Using Docker)


## Other Platforms

We provide installation instructions for setting up Crossbar.io on your own systems for different operating systems or environments.

* [Installation on (generic) Linux](Installation on Linux)
* [Installation on Mac OS X](Installation on Mac OS X)
* [Installation on Windows](Installation on Windows)


## Devices

Crossbar.io runs on Linux based embedded devices. Here are specific recipes:

* [Installation on RaspberryPi](Installation on RaspberryPi)
* [Installation on Ubuntu Snappy](Installation on Ubuntu Snappy)


## Setup in the Cloud

Crossbar.io runs great on *Infrastructure-as-a-Service (Iaas)* providers like [Amazon EC2](http://aws.amazon.com/ec2/) or [Microsoft Azure](http://azure.microsoft.com/):

* [Setup on Microsoft Azure](Setup-on-Microsoft-Azure)
* [Setup on Amazon EC2](Setup-on-Amazon-EC2)

Additionally, Crossbar.io can be run on *Platform-as-a-Service (PaaS)* providers:

* [Setup on Heroku](Setup-on-Heroku)
* [Setup on OpenShift](Setup-on-OpenShift)


## Demo Instance

For light-weight testing purposes, you might also use our public demo instances of Crossbar.io:

* [Demo Instance](Demo Instance)

> The public demo instances of Crossbar.io is provided as a convenience, and for free. Please only use it for development and testing purposes. We don't make any guarantees whatsoever, and the service might be restricted in the future.
